Thread (4 messages) 4 messages, 2 authors, 2020-11-19

Re: [PATCH 1/2] tests: make sure nested lazy prereqs work reliably

From: Jeff King <hidden>
Date: 2020-11-19 15:58:31
Subsystem: the rest · Maintainer: Linus Torvalds

On Wed, Nov 18, 2020 at 08:04:13PM +0100, SZEDER Gábor wrote:
So to prevent nested prereqs from interfering with each other let's
evaluate each prereq in its own dedicated directory by appending the
prereq's name to the directory name, e.g. 'prereq-test-dir-SYMLINKS'.
In the test we check not only that the prereq test dir is still there,
but also that the inner prereq can't mess with the outer prereq's
files.
That sounds reasonable. I do wonder, though, whether simply creating the
prereq directory in the _current_ directory would be sufficient. Then
you'd get prereq-test-dir/prereq-test-dir for a nested invocation. But
the prereqs aren't supposed to care about which specific directory
they're in.

I.e., your test passes equally well with just:
diff --git a/t/test-lib-functions.sh b/t/test-lib-functions.sh
index 59bbf75e83..f5dc6801d9 100644
--- a/t/test-lib-functions.sh
+++ b/t/test-lib-functions.sh
@@ -474,15 +474,15 @@ test_lazy_prereq () {
 
 test_run_lazy_prereq_ () {
 	script='
-mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
+mkdir -p "prereq-test-dir" &&
 (
-	cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
+	cd "prereq-test-dir" &&'"$2"'
 )'
 	say >&3 "checking prerequisite: $1"
 	say >&3 "$script"
 	test_eval_ "$script"
 	eval_ret=$?
-	rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
+	rm -rf "prereq-test-dir"
 	if test "$eval_ret" = 0; then
 		say >&3 "prerequisite $1 ok"
 	else
though I guess it is not really much simpler (it avoids the funky
quoting around $1 in the embedded script, but we already have that for
$2). And perhaps debugging is easier with a more predictable and
descriptive directory name.
+test_lazy_prereq NESTED_INNER '
+	>inner &&
+	rm -f outer
+'
+test_lazy_prereq NESTED_PREREQ '
+	>outer &&
+	test_have_prereq NESTED_INNER &&
+	echo "can create new file in cwd" >file &&
+	test -f outer &&
+	test ! -f inner
+'
+test_expect_success NESTED_PREREQ 'evaluating nested lazy prereqs dont interfere with each other' '
+	nestedworks=yes
+'
+
+if test -z "$GIT_TEST_FAIL_PREREQS_INTERNAL" && test "$nestedworks" != yes
+then
+	say 'bug in test framework: nested lazy prerequisites do not work'
+	exit 1
+fi
I was surprised to see this bare exit, because I know we have some
functions (run_sub_test_*) to help with testing the framework itself. It
looks like the other prereq tests don't use it either, though. I wonder
if there is a technical reason, or if they were simply added at a
different time. (Either way, I am OK for your new test to match the
surrounding ones like you have here).

-Peff
Keyboard shortcuts
hback out one level
jnext message in thread
kprevious message in thread
ldrill in
Escclose help / fold thread tree
?toggle this help